.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ODListBox.inc

.code

DlgProc proc uses ebx,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	rect:RECT
	LOCAL	szItem[MAX_PATH]:BYTE

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		; Add som items to the listbox
		mov		ebx,offset szListItems
		.while byte ptr [ebx]
			invoke SendDlgItemMessage,hWin,IDC_LST1,LB_ADDSTRING,0,ebx
			; Point to next string
			invoke lstrlen,ebx
			lea		ebx,[ebx+eax+1]
		.endw
		; Set the checkbox for first item in the list
		invoke SendDlgItemMessage,hWin,IDC_LST1,LB_SETITEMDATA,0,TRUE
		; Set the checkbox for third item in the list
		invoke SendDlgItemMessage,hWin,IDC_LST1,LB_SETITEMDATA,2,TRUE
		; Select the first item
		invoke SendDlgItemMessage,hWin,IDC_LST1,LB_SETCURSEL,0,0
	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if eax==IDC_LST1 && edx==LBN_DBLCLK
			; Listbox item double clicked
			; Get current selected item
			invoke SendDlgItemMessage,hWin,IDC_LST1,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				; Index to ebx
				mov		ebx,eax
				; Get current checkbox value
				invoke SendDlgItemMessage,hWin,IDC_LST1,LB_GETITEMDATA,ebx,0
				; Invert it
				xor		eax,TRUE
				; Update checkbox value
				invoke SendDlgItemMessage,hWin,IDC_LST1,LB_SETITEMDATA,ebx,eax
				; Force a repaint of the item
				invoke SendDlgItemMessage,hWin,IDC_LST1,LB_GETITEMRECT,ebx,addr rect
				; Get listbox handle
				invoke GetDlgItem,hWin,IDC_LST1
				mov		ebx,eax
				invoke InvalidateRect,ebx,addr rect,TRUE
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.elseif eax==WM_DRAWITEM
		mov		esi,lParam
		; Select back and text colors
		mov		eax,[esi].DRAWITEMSTRUCT.itemState
		test	eax,ODS_SELECTED
		.If !ZERO?
			invoke GetSysColor,COLOR_HIGHLIGHTTEXT
			invoke SetTextColor,[esi].DRAWITEMSTRUCT.hdc,eax
			invoke GetSysColor,COLOR_HIGHLIGHT
			invoke SetBkColor,[esi].DRAWITEMSTRUCT.hdc,eax
		.else
			invoke GetSysColor,COLOR_WINDOWTEXT
			invoke SetTextColor,[esi].DRAWITEMSTRUCT.hdc,eax
			invoke GetSysColor,COLOR_WINDOW
			invoke SetBkColor,[esi].DRAWITEMSTRUCT.hdc,eax
		.endif
		; Draw selected / unselected back color
		invoke ExtTextOut,[esi].DRAWITEMSTRUCT.hdc,0,0,ETO_OPAQUE,addr [esi].DRAWITEMSTRUCT.rcItem,NULL,0,NULL
		; Draw the checkbox
		mov		eax,[esi].DRAWITEMSTRUCT.rcItem.left
		inc		eax
		mov		rect.left,eax
		add		eax,13
		mov		rect.right,eax
		mov		eax,[esi].DRAWITEMSTRUCT.rcItem.top
		inc		eax
		mov		rect.top,eax
		add		eax,13
		mov		rect.bottom,eax
		mov		eax,DFCS_BUTTONCHECK Or DFCS_FLAT
		.If [esi].DRAWITEMSTRUCT.itemData
			; Checkbox is checked
			or		eax,DFCS_CHECKED
		.endif
		invoke DrawFrameControl,[esi].DRAWITEMSTRUCT.hdc,addr rect,DFC_BUTTON,eax
		; Draw the text
		invoke SendMessage,[esi].DRAWITEMSTRUCT.hwndItem,LB_GETTEXT,[esi].DRAWITEMSTRUCT.itemID,addr szItem
		mov		edx,[esi].DRAWITEMSTRUCT.rcItem.left
		add		edx,18
		invoke TextOut,[esi].DRAWITEMSTRUCT.hdc,edx,[esi].DRAWITEMSTRUCT.rcItem.top,addr szItem,eax
		invoke GetFocus
		.if eax==[esi].DRAWITEMSTRUCT.hwndItem
			; Let windows draw the focus rectangle
			xor		eax,eax
			jmp		Ex
		.endif
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
  Ex:
	ret

DlgProc endp

;########################################################################

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

end start
